﻿using Microsoft.ML.Data;
using System;

namespace DataTransformation.Models
{
    public class TransformedData
    {
        [ColumnName("Review")]
        public string Original { get; set; }
        [ColumnName("NormalizedSentiment")]
        public string Text { get; set; }
        [ColumnName("Tokens")]
        public string[] Tokens { get; set; }
        [ColumnName("NoStopWords")]
        public string[] NoStopWords { get; set; }
        [ColumnName("Values")]
        public UInt32[] Values { get; set; }

        public void Print(Action<string> writeAction)
        {
            writeAction($"Original: {Original + Environment.NewLine} Normalized: {Text + Environment.NewLine} Words: {string.Join(", ", Tokens) + Environment.NewLine} Without stop words: {string.Join(", ", NoStopWords) + Environment.NewLine} Vector: {string.Join(", ", Values)}");
        }
    }
}
