﻿using DataTransformation.Common;
using DataTransformation.Models;
using Microsoft.ML;
using System;
using System.Linq;

namespace DataTransformation
{
    class Program
    {
        static void Main(string[] args)
        {
            var inMemoryArray = new SentimentModel[]
            {
                new SentimentModel(){Text="So far the book seems like it would be a nice way to learn c# and .Net, However, after trying to use this on a windows machine im getting constant errors and all the book does is say If you are experiencing this error click this link and they provide a link to Microsoft documentation that is just to setup or locate certain functions like csc.exe (The books basically says sorry I only know how to write books, gotta fix it on your own, I can't help ya) This book also uses visual studio code which is one of the most difficult cross platform Ide's to learn. If you are starting out and wanting to learn how to program C# just youtube a channel called Giraffe academy. They show you how to use Visual studio and how to actually program correctly with no issues. I wish I could refund this garbage." },
                new SentimentModel(){Text="I expected much more. It is merely more than a collection of examples with loads of cross references. Less would have been much more.do not recommend to buy it." },
                new SentimentModel(){Text="If you want to learn c# this is the book for you. Well layed out with great examples. Takes you through the language step by step." },
                new SentimentModel(){Text="I'm a mid-level web developer who wanted to learn about c# deeply. The book is very interesting and easy to read. I would suggest this book to those who already got some understanding of programming or have good technical thinking. I would prefer the book could be a color painted and highlighted generic types classes objects Interested to buy the author's other books too."},
                new SentimentModel(){Text="I've been trying to learn C# Razor Pages, and this has been very helpful." }
            };
            var mlContext = new MLContext();
            var data = mlContext.Data.LoadFromEnumerable<SentimentModel>(inMemoryArray);
            var pipeline = mlContext.Transforms.Text.NormalizeText("NormalizedSentiment", "Review", keepPunctuations: false)
                .Append(mlContext.Transforms.Text.TokenizeIntoWords("Tokens", "NormalizedSentiment"))
                .Append(mlContext.Transforms.Text.RemoveDefaultStopWords("NoStopWords", "Tokens"))
                .Append(mlContext.Transforms.Conversion.MapValueToKey("Values", "NoStopWords"));
            var preview = pipeline.Fit(data).Transform(data);
            var transformedData = mlContext.Data.CreateEnumerable<TransformedData>(preview, reuseRowObject: false);
            transformedData.ForEach((item) => item.Print(Console.WriteLine));
            Console.ReadLine();
        }
    }
}
